<template>
  <el-container>
    <el-main>
      <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small" style="max-width: 500px;">
        <el-form-item prop="vuforiaImageGroupId" label="所属图集ID">
          <template>
            <el-select v-model="formData.vuforiaImageGroupId" clearable placeholder="请选择" :disabled="'vuforiaImageGroupId'==subColumn">
              <el-option v-for="item in vuforiaImageGroupIdOptions" :key="item.value" :label="item.label" :value="item.value"></el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item prop="name" label="识别图名称">
          <el-input v-model="formData.name" :disabled="'name'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="vuforiaImageTypeId" label="识别图类型ID">
          <template>
            <el-select v-model="formData.vuforiaImageTypeId" clearable placeholder="请选择" :disabled="'vuforiaImageTypeId'==subColumn">
              <el-option v-for="item in vuforiaImageTypeIdOptions" :key="item.value" :label="item.label" :value="item.value"></el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item prop="areaMarking" label="区域标记编号">
          <el-input v-model="formData.areaMarking" :disabled="'areaMarking'==subColumn"></el-input>
        </el-form-item>

        <el-form-item prop="vuforiaImage" label="识别图">
          <single-upload v-model="formData.vuforiaImage" :disabled="'vuforiaImage'==subColumn"></single-upload>
        </el-form-item>
        <el-form-item prop="vuforiaImage" label="识别图URL">
          <el-input v-model="formData.vuforiaImage" :disabled="'vuforiaImage'==subColumn"></el-input>
        </el-form-item>

        <el-form-item prop="landMarkId" label="所属地标ID">
          <template>
            <el-select v-model="formData.landMarkId" clearable placeholder="请选择" :disabled="'landMarkId'==subColumn">
              <el-option v-for="item in landMarkIdOptions" :key="item.value" :label="item.label" :value="item.value"></el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item prop="arContentGroupId" label="AR内容组ID">
          <el-input v-model="formData.arContentGroupId" :disabled="'arContentGroupId'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="posX" label="坐标X">
          <el-input v-model="formData.posX" :disabled="'posX'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="posY" label="坐标Y">
          <el-input v-model="formData.posY" :disabled="'posY'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="posZ" label="坐标Z">
          <el-input v-model="formData.posZ" :disabled="'posZ'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="angle" label="角度">
          <el-input v-model="formData.angle" :disabled="'angle'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="remark1" label="备注1">
          <el-input v-model="formData.remark1" :disabled="'remark1'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="remark2" label="备注2">
          <el-input v-model="formData.remark2" :disabled="'remark2'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="remark3" label="备注3">
          <el-input v-model="formData.remark3" :disabled="'remark3'==subColumn"></el-input>
        </el-form-item>
        <el-form-item prop="targetId" label="targetId">
          <el-input v-model="formData.targetId"></el-input>
        </el-form-item>
        <el-form-item prop="mapIndex" label="index">
          <el-input v-model="formData.mapIndex" disabled></el-input>
        </el-form-item>

        <el-form-item>
          <el-button @click="onSave" :loading="$store.state.fetchingData" type="primary">保存</el-button>
          <el-button @click="onDelete" v-if="formData.id" type="danger">删除</el-button>
          <el-button @click="$router.go(-1)">取消</el-button>
        </el-form-item>
      </el-form>
    </el-main>

    <el-aside width="640px" v-if="landmarkId">
      <el-card style="height:660px;">
        <drug-area ref="drugAreaContent" :doorFlag="false" :isAreaShowPoint="false" :areaWidth="areaWidth" :areaHeight="areaHeight" :landmarkId="landmarkId" :areaId="areaId" :mapPointInfo="mapPointInfo" @mapAddition="mapAddition" @subtraction="subtraction" @choosePoint="choosePoint"></drug-area>
      </el-card>
    </el-aside>
  </el-container>
</template>
<script>
import formValidator from '../formValidator'
import drugArea from '../components/DrugArea'

export default {
  created() {
    if (this.$route.query.column) {
      this.subColumn = this.$route.query.column.split(',')[1];
      this.subValue = this.$route.query.column.split(',')[0];
    }

    if (this.$route.query.id) {
      this.$http.get({
        url: '/vuforiaImageInfo/getOne',
        data: {
          id: this.$route.query.id
        }
      }).then(res => {
        if (res.success) {


          this.formData = res.data;

          if (this.$route.query.column) {
            this.formData[this.subColumn] = this.subValue;
          }
        }
      })
    } else {
      if (this.$route.query.column) {
        this.formData[this.subColumn] = this.subValue;
      }
    }




    this.$http.get({
      url: '/vuforiaImageGroup/all'
    }).then(res => {
      if (res.success) {

        if (res.data.length > 0) {
          res.data.forEach(item => {
            this.vuforiaImageGroupIdOptions.push({ label: item.vuforiaName, value: String(item.id) });
          })
        }
      }
    });



    this.$http.get({
      url: '/vuforiaImageType/all'
    }).then(res => {
      if (res.success) {

        if (res.data.length > 0) {
          res.data.forEach(item => {
            this.vuforiaImageTypeIdOptions.push({ label: item.typeName, value: String(item.id) });
          })
        }
      }
    });



    this.$http.get({
      url: '/landMark/all'
    }).then(res => {
      if (res.success) {

        if (res.data.length > 0) {
          res.data.forEach(item => {
            this.landMarkIdOptions.push({ label: item.mapName, value: String(item.id) });
          })
        }
      }
    });
  },
  data() {
    return {
      saving: false,
      formData: {},
      rules: {
      },
      vuforiaImageGroupIdOptions: [],
      vuforiaImageTypeIdOptions: [],
      landMarkIdOptions: [],
      subColumn: '',
      subValue: '',
      areaWidth: 600,
      areaHeight: 600,
    }
  },
  computed: {
    mapPointInfo() {
      return {
        x: this.formData.posX || '',
        y: this.formData.posY || '',
        index: this.formData.mapIndex || ""
      }
    },
    landmarkId() {
      return Number(this.formData.landMarkId)
    },
    areaId() {
      return Number(this.formData.areaId)
    }
  },
  methods: {
    choosePoint(jsonp) {
      this.formData.posX = jsonp.x;
      this.formData.posY = jsonp.y;
      this.formData.mapIndex = jsonp.index
    },
    mapAddition() {
      // if (this.areaWidth < 900) {
        this.areaWidth += 500
        this.areaHeight += 500
      // }

    },
    subtraction() {
      // if (this.areaWidth > 600) {
        this.areaWidth -= 500
        this.areaHeight -= 500
      // }
    },
    onSave() {
      this.$refs.form.validate((valid) => {
        if (valid) {
          this.submit();
        } else {
          return false;
        }
      });
    },
    submit() {
      var data = JSON.parse(JSON.stringify(this.formData));
      if (data.posX && data.posY && Number(data.posX) < Number(this.$refs.drugAreaContent.width) && Number(data.posY) < Number(this.$refs.drugAreaContent.height)) {
        data.mapIndex = Number(data.posX) * Number(this.$refs.drugAreaContent.width) + Number(data.posY)
      }
      this.$http.post({
        url: this.formData.id ? '/vuforiaImageInfo/update' : '/vuforiaImageInfo/save',
        data: data
      }).then(res => {
        if (res.success) {
          this.$message.success('成功');
          this.$router.go(-1);
        } else {
          this.$message.warning('失败')
        }
      });
    },
    onDelete() {
      this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
        return this.$http.post({
          url: '/vuforiaImageInfo/del',
          data: { id: this.formData.id }
        })
      }).then(res => {
        if (res.success) {
          this.$message.success('删除成功');
          this.$router.go(-1);

        } else {
          this.$message.error(res.error);
        }
      }).catch(action => {
        if (action === 'cancel') {
          this.$message.info('删除取消');
        } else {
          this.$message.error('删除失败');
        }
      })
    },
  },
  components: {
    drugArea
  }
}
</script>
<style lang="less" scoped>
</style>
